#define MAX_ERRORS	20
#define MAX_LEVELS	32
#define MAX_SYMBOLS	1024
#define MAX_TYPES	1024

void yyerror(char *message);
void block_start(void);
void block_end(void);
void init_prog(void);
void add_symbol(char *name, int type);
int make_type(int base, int modifier);
int get_type(int base, int modifier);
int get_function(int listtype, int rettype);
int ret_type(int functype);
int arg_list(int functtype);
int is_function(int functtype);
int symbol_exists(char *name);
int get_symbol_type(char *name);
int deref_type(int type, int mod);

/* predefined types */
#define TYPE_INTEGER	0
#define TYPE_EMPTYLIST	1


/* modifiers (must be negative) */
#define TYPE_REF	-1
#define TYPE_ROW	-2

/* classes of types */
#define TYPE_REGULAR	0
#define TYPE_FUNCTION	1

/* compatibility */
#define FLEX_SCANNER
